﻿[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12
$modulePath = 'C:\dll\Microsoft.ConfigurationManagement.Messaging.dll'
Import-Module $modulePath

#Const
$ADDPROP_Name = [Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Name
$ADDPROP_GUID = [Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Guid
$ADDPROP_Key = [Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Key
$ADDPROP_None = [Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::None


#Your site code
$siteCode = 'J16'

#Tesla User Name and Password
$username = "email"
$password = "password"

$secstr = New-Object -TypeName System.Security.SecureString
$password.ToCharArray() | ForEach-Object {$secstr.AppendChar($_)}
$cred = new-object -typename System.Management.Automation.PSCredential -argumentlist $username, $secstr

Connect-Tesla -Credential $cred


# Connect-Tesla 

$vehicles = Get-Tesla -Command vehicles
$vehicle_state = Get-Tesla -Command vehicle_state


$NetbiosName = $vehicle_state.vehicle_name
$SN = $vehicles.vin
$GUID = $vehicles.vin
$Name = $vehicle_state.vehicle_name
$version = $vehicle_state.car_version
$NLat = $drive_state.native_latitude
$NLong = $drive_state.native_longitude
$TOption = $vehicles.option_codes



#System Method
$agentName = 'Enhansoft Tesla System'
$Architecture = 'System'

$ResName = "AcerAspire"
$q = 'Select * from SMS_R_System where Name="'+$ResName+'"'

$Sddr=Get-WmiObject -query $q -ComputerName CM16-clean -Namespace "root/sms/site_$siteCode"

$ddr = New-Object -typename Microsoft.ConfigurationManagement.Messaging.Messages.Server.DiscoveryDataRecordFile -ArgumentList $agentName
$ddr.SiteCode = $siteCode
$ddr.Architecture = $Architecture
$ddr.AddStringProperty('SMS Unique Identifier', $ADDPROP_GUID -bor $ADDPROP_KEY, 64, $Sddr.SMSUniqueIdentifier)
$ddr.AddStringProperty('TName', $ADDPROP_None, 32, "$Name")
$ddr.AddStringProperty('TSerial Number', $ADDPROP_None, 64, "$SN")
$ddr.AddStringProperty('TNlat', $ADDPROP_None, 64, "$NLat")
$ddr.AddStringProperty('TNLong', $ADDPROP_None, 64, "$Nlong")
$ddr.AddStringProperty('TVersion', $ADDPROP_None, 64, "$Version")
$ddr.AddStringProperty('TOptions', $ADDPROP_None, 800, "$TOption")
$Ddr.SerializeToFile([System.Environment]::GetFolderPath("Desktop") + "\Tesla\")


#Custom
$agentName = 'Enhansoft Tesla Custom'
$Architecture = 'Enhansoft Tesla'


$ddr = New-Object -typename Microsoft.ConfigurationManagement.Messaging.Messages.Server.DiscoveryDataRecordFile -ArgumentList $agentName
$ddr.SiteCode = $siteCode
$ddr.Architecture = $Architecture
$ddr.AddStringProperty('TName', $ADDPROP_Name, 32, "$Name")
$ddr.AddStringProperty('TSerial Number', $ADDPROP_Key, 64, "$SN")
$ddr.AddStringProperty('TNlat', $ADDPROP_None, 64, "$NLat")
$ddr.AddStringProperty('TNLong', $ADDPROP_None, 64, "$Nlong")
$ddr.AddStringProperty('TVersion', $ADDPROP_None, 64, "$Version")
$ddr.AddStringProperty('TOptions', $ADDPROP_None, 800, "$TOption")
$Ddr.SerializeToFile([System.Environment]::GetFolderPath("Desktop") + "\Tesla\")


